Index: /trunk/src/sh_unix.c
===================================================================
--- /trunk/src/sh_unix.c	(revision 584)
+++ /trunk/src/sh_unix.c	(revision 1)
@@ -3281,57 +2459,57 @@
  */
 
-  if (*flags == 0)
-    goto theend;
-
-#ifdef FS_SECRM_FL
-  if ( (*flags & FS_SECRM_FL) != 0  )  { c_attr[0] = 's'; keep_flags |= FS_SECRM_FL; }
-#endif
-#ifdef FS_UNRM_FL 
-  if ( (*flags & FS_UNRM_FL) != 0   )  { c_attr[1] = 'u'; keep_flags |= FS_UNRM_FL; }
-#endif
-#ifdef FS_SYNC_FL
-  if ( (*flags & FS_SYNC_FL) != 0    ) { c_attr[2] = 'S'; keep_flags |= FS_SYNC_FL; }
-#endif
-#ifdef FS_IMMUTABLE_FL
-  if ( (*flags & FS_IMMUTABLE_FL) != 0) { c_attr[3] = 'i'; keep_flags |= FS_IMMUTABLE_FL; }
-#endif
-#ifdef FS_APPEND_FL
-  if ( (*flags & FS_APPEND_FL) != 0  )  { c_attr[4] = 'a'; keep_flags |= FS_APPEND_FL; }
-#endif
-#ifdef FS_NODUMP_FL
-  if ( (*flags & FS_NODUMP_FL) != 0  )  { c_attr[5] = 'd'; keep_flags |= FS_NODUMP_FL; }
-#endif
-#ifdef FS_NOATIME_FL
-  if ( (*flags & FS_NOATIME_FL) != 0)   { c_attr[6] = 'A'; keep_flags |= FS_NOATIME_FL; }
-#endif
-#ifdef FS_COMPR_FL
-  if ( (*flags & FS_COMPR_FL) != 0   )  { c_attr[7] = 'c'; keep_flags |= FS_COMPR_FL; }
-#endif
-
-#ifdef FS_TOPDIR_FL
-  if ( (*flags & FS_TOPDIR_FL) != 0  )  { c_attr[8] = 'T'; keep_flags |= FS_TOPDIR_FL; }
-#endif
-#ifdef FS_DIRSYNC_FL
-  if ( (*flags & FS_DIRSYNC_FL) != 0 )  { c_attr[9] = 'D'; keep_flags |= FS_DIRSYNC_FL; }
-#endif
-#ifdef FS_NOTAIL_FL
-  if ( (*flags & FS_NOTAIL_FL) != 0  )  { c_attr[10] = 't'; keep_flags |= FS_NOTAIL_FL; }
-#endif
-#ifdef FS_JOURNAL_DATA_FL
-  if ( (*flags & FS_JOURNAL_DATA_FL) != 0)  { c_attr[11] = 'j'; keep_flags |= FS_JOURNAL_DATA_FL; }
-#endif
-
-  *flags = keep_flags;
-  
- theend:
-  /* !HAVE_STAT_FLAGS */
-#endif
-
-  c_attr[ATTRBUF_USED] = '\0';
+#ifdef EXT2_SECRM_FL
+  if ( (*flags & EXT2_SECRM_FL) != 0  )   c_attr[0] = 's';
+#endif
+#ifdef EXT2_UNRM_FL 
+  if ( (*flags & EXT2_UNRM_FL) != 0   )   c_attr[1] = 'u';
+#endif
+#ifdef EXT2_SYNC_FL
+  if ( (*flags & EXT2_SYNC_FL) != 0    )  c_attr[2] = 'S';
+#endif
+#ifdef EXT2_IMMUTABLE_FL
+  if ( (*flags & EXT2_IMMUTABLE_FL) != 0) c_attr[3] = 'i';
+#endif
+#ifdef EXT2_APPEND_FL
+  if ( (*flags & EXT2_APPEND_FL) != 0  )  c_attr[4] = 'a';
+#endif
+#ifdef EXT2_NODUMP_FL
+  if ( (*flags & EXT2_NODUMP_FL) != 0  )  c_attr[5] = 'd';
+#endif
+#ifdef EXT2_NOATIME_FL
+  if ( (*flags & EXT2_NOATIME_FL) != 0)   c_attr[6] = 'A';
+#endif
+#ifdef EXT2_COMPR_FL
+  if ( (*flags & EXT2_COMPR_FL) != 0   )  c_attr[7] = 'c';
+#endif
+#ifdef EXT2_COMPRBLK_FL
+  if ( (*flags & EXT2_COMPRBLK_FL) != 0)  c_attr[8] = 'B';
+#endif
+#ifdef EXT2_DIRTY_FL
+  if ( (*flags & EXT2_DIRTY_FL) != 0   )  c_attr[9] = 'D';
+#endif
+#ifdef EXT2_NOCOMPR_FL
+  if ( (*flags & EXT2_NOCOMPR_FL) != 0 )  c_attr[10] = 'D';
+#endif
+#ifdef EXT2_ECOMPR_FL
+  if ( (*flags & EXT2_ECOMPR_FL) != 0  )  c_attr[11] = 'D';
+#endif
+
+  c_attr[12] = '\0';
 
   SL_RETURN(0, _("sh_unix_getinfo_attr"));
 }
-
-/* defined(__linux__) || defined(HAVE_STAT_FLAGS) */
+#else
+static 
+int sh_unix_getinfo_attr (char * name, 
+			  unsigned long * flags, 
+			  char * c_attr,
+			  int fd)
+{
+  return 0;
+}
+#endif
+
+/* __LINUX__ */
 #endif
 
@@ -3373,12 +2551,4 @@
     c_mode[0] = 's';
   }
-  else if ( S_ISDOOR(buf->st_mode) ) {
-    (*type)   = SH_FILE_DOOR;
-    c_mode[0] = 'D';
-  }
-  else if ( S_ISPORT(buf->st_mode) ) {
-    (*type)   = SH_FILE_PORT;
-    c_mode[0] = 'P';
-  }
   else                              {
     (*type)   = SH_FILE_UNKNOWN;
@@ -3391,5 +2561,5 @@
 int sh_unix_get_ftype(char * fullpath)
 {
-  char        c_mode[CMODE_SIZE];
+  char        c_mode[16];
   struct stat buf;
   ShFileType  type;
@@ -3480,4 +2650,5 @@
 	      someval *= 1000;  /* milliseconds in a second */
 	      sometime = (unsigned long) someval;
+	      /* fprintf(stderr, "FIXME PAUSE %ld\n", sometime); */
 	      retry_msleep(0, sometime);
 	    }
@@ -3485,4 +2656,5 @@
 	    {
 	      sometime = (unsigned long) someval;
+	      /* fprintf(stderr, "FIXME PAUSE %ld sec\n", sometime); */
 	      retry_msleep (sometime, 0);
 	    }
@@ -3492,5 +2664,5 @@
 }
 
-int sh_unix_set_io_limit (const char * c)
+int sh_unix_set_io_limit (char * c)
 {
   long val;
@@ -3515,308 +2687,5 @@
 #include "sh_ignore.h"
 
-int sh_unix_checksum_size (char * filename, off_t size, int is_max_size, 
-			   char * fileHash, int alert_timeout, SL_TICKET fd, unsigned long mask)
-{
-  file_type * tmpFile;
-  int status;
-
-  SL_ENTER(_("sh_unix_checksum_size"));
-
-  tmpFile = SH_ALLOC(sizeof(file_type));
-  tmpFile->link_path = NULL;
-
-  if (sh.flag.checkSum != SH_CHECK_INIT)
-    {
-      /* lookup file in database */
-      if (is_max_size == S_TRUE) {
-	status = sh_hash_get_it (filename, tmpFile, NULL);
-	if ((status != 0) || (tmpFile->size > size)) {
-	  goto out;
-	}
-      } else {
-	tmpFile->size = size;
-      }
-    }
-  else
-    {
-      tmpFile->size = size;
-    }
-
-  /* if last <= current get checksum */
-  if (tmpFile->size <= size)
-    {
-      char hashbuf[KEYBUF_SIZE];
-      UINT64 local_length = (UINT64) (tmpFile->size < 0 ? 0 : tmpFile->size);
-      if (sh.flag.opts == S_TRUE) sh_tiger_set_hashtype_mask(mask);
-      sl_strlcpy(fileHash,
-		 sh_tiger_generic_hash (filename, fd, &(local_length), 
-					alert_timeout, hashbuf, sizeof(hashbuf)),
-		 KEY_LEN+1);
-      
-       /* return */
-      if (tmpFile->link_path)   SH_FREE(tmpFile->link_path);
-      SH_FREE(tmpFile);
-      SL_RETURN( 0, _("sh_unix_checksum_size"));
-    }
-
- out:
-  if (tmpFile->link_path)   SH_FREE(tmpFile->link_path);
-  SH_FREE(tmpFile);
-  sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
-  SL_RETURN( -1, _("sh_unix_checksum_size"));
-}
-
-/********************************************************
- * Search rotated logfile
- */
-extern char * sh_rotated_log_search(const char * path, struct stat * buf);
-
-int sh_check_rotated_log (const char * path,  
-			  UINT64 old_size, UINT64 old_inode, const char * old_hash, unsigned long mask)
-{
-  struct stat obuf;
-  UINT64 length_nolim = TIGER_NOLIM;
-  int retval = S_FALSE;
-
-  if (old_size != length_nolim)
-    {
-      char hashbuf[KEYBUF_SIZE];
-      char * rotated_file;
-
-      obuf.st_ino = old_inode;
-      rotated_file = sh_rotated_log_search(path, &obuf);
-
-      if (rotated_file && (0 != strcmp(path, rotated_file)))
-	{
-	  SL_TICKET fd = sl_open_fastread (FIL__, __LINE__, rotated_file, SL_YESPRIV);
-	  if (!SL_ISERROR(fd))
-	    {
-	      sh_unix_checksum_size (rotated_file, old_size, S_FALSE, 
-				     hashbuf, 120 /* alert_timeout */, fd, mask);
-	      
-	      sl_close(fd);
-	      
-	      if (strncmp (old_hash, hashbuf, KEY_LEN) == 0) {
-		retval = S_TRUE;
-	      }
-	    }
-	}
-      if (rotated_file) {
-	SH_FREE(rotated_file);
-      }
-    }
-  return retval;
-}
-
-
-int sh_unix_check_selinux = S_FALSE;
-int sh_unix_check_acl     = S_FALSE;
-int sh_unix_check_attributes  = S_TRUE;
-
-#ifdef USE_ACL
-
-#include <sys/acl.h>
-static char * sh_unix_getinfo_acl (char * path, int fd, struct stat * buf)
-{
-  /* system.posix_acl_access, system.posix_acl_default
-   */
-  char *  out  = NULL;
-  char *  collect = NULL;
-  char *  tmp;
-  char *  out_compact;
-  ssize_t len;
-  acl_t   result;
-
-  SL_ENTER(_("sh_unix_getinfo_acl"));
-
-  result = (fd == -1) ? 
-    acl_get_file (path, ACL_TYPE_ACCESS) :
-    acl_get_fd   (fd);
-
-  if (result)
-    {
-      out = acl_to_text (result, &len);
-      if (out && (len > 0)) {
-	out_compact = sh_util_acl_compact (out, len);
-	acl_free(out);
-	if (out_compact) 
-	  {
-	    collect = sh_util_strconcat (_("acl_access:"), out_compact, NULL);
-	    SH_FREE(out_compact);
-	  }
-      }
-      acl_free(result);
-    }
-  
-  
-  if ( S_ISDIR(buf->st_mode) ) 
-    {
-      result = acl_get_file (path, ACL_TYPE_DEFAULT);
-      
-      if (result)
-	{
-	  out = acl_to_text (result, &len);
-	  if (out && (len > 0)) {
-	    out_compact = sh_util_acl_compact (out, len);
-	    acl_free(out);
-	    if (out_compact) {
-	      if (collect) {
-		tmp = sh_util_strconcat (_("acl_default:"), 
-					 out_compact, ":", collect, NULL);
-		SH_FREE(collect);
-	      }
-	      else {
-		tmp = sh_util_strconcat (_("acl_default:"), out_compact, NULL);
-	      }
-	      SH_FREE(out_compact);
-	      collect = tmp;
-	    }
-	  }
-	  acl_free(result);
-	}
-    }
-  
-  SL_RETURN((collect),_("sh_unix_getinfo_acl"));
-}
-#endif
-
-#ifdef USE_XATTR
-
-#include <attr/xattr.h>
-static char * sh_unix_getinfo_xattr_int (char * path, int fd, char * name)
-{
-  char *  out   = NULL;
-  char *  tmp   = NULL;
-  size_t  size  = 256;
-  ssize_t result;
-
-  SL_ENTER(_("sh_unix_getinfo_xattr_int"));
-
-  out = SH_ALLOC(size);
-
-  result = (fd == -1) ? 
-    lgetxattr (path, name, out, size-1) :
-    fgetxattr (fd,   name, out, size-1);
-
-  if (result == -1 && errno == ERANGE) 
-    {
-      SH_FREE(out);
-      result = (fd == -1) ? 
-	lgetxattr (path, name, NULL, 0) :
-	fgetxattr (fd,   name, NULL, 0);
-      size = result + 1;
-      out  = SH_ALLOC(size);
-      result = (fd == -1) ? 
-	lgetxattr (path, name, out, size-1) :
-	fgetxattr (fd,   name, out, size-1);
-    }
-
-  if ((result > 0) && ((size_t)result < size))
-    {
-      out[size-1] = '\0';
-      tmp = out;
-    }
-  else
-    {
-      SH_FREE(out);
-    }
-
-  SL_RETURN((tmp),_("sh_unix_getinfo_xattr_int"));
-}
-
-
-static char * sh_unix_getinfo_xattr (char * path, int fd, struct stat * buf)
-{
-  /* system.posix_acl_access, system.posix_acl_default, security.selinux 
-   */
-  char *  tmp;
-  char *  out  = NULL;
-  char *  collect = NULL;
-
-  SL_ENTER(_("sh_unix_getinfo_xattr"));
-
-#ifdef USE_ACL
-  /*
-   * we need the acl_get_fd/acl_get_file functions, getxattr will only
-   * yield the raw bytes
-   */
-  if (sh_unix_check_acl == S_TRUE) 
-    {
-      out = sh_unix_getinfo_acl(path, fd, buf);
-      
-      if (out)
-	{
-	  collect = out;
-	}
-  }
-#else
-  (void) buf;
-#endif
-
-  if (sh_unix_check_selinux == S_TRUE)
-    {
-      out = sh_unix_getinfo_xattr_int(path, fd, _("security.selinux"));
-
-      if (out)
-	{
-	  if (collect) {
-	    tmp = sh_util_strconcat(_("selinux:"), out, ":", collect, NULL);
-	    SH_FREE(collect);
-	  }
-	  else {
-	    tmp = sh_util_strconcat(_("selinux:"), out, NULL);
-	  }
-	  SH_FREE(out);
-	  collect = tmp;
-	}
-    }
-
-  SL_RETURN((collect),_("sh_unix_getinfo_xattr"));
-}
-#endif
-
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
-int sh_unix_setcheckattributes (const char * c)
-{
-  int i;
-  SL_ENTER(_("sh_unix_setcheckattributes"));
-  i = sh_util_flagval(c, &(sh_unix_check_attributes));
-
-  SL_RETURN(i, _("sh_unix_setcheckattributes"));
-}
-#endif
-
-#ifdef USE_XATTR
-int sh_unix_setcheckselinux (const char * c)
-{
-  int i;
-  SL_ENTER(_("sh_unix_setcheckselinux"));
-  i = sh_util_flagval(c, &(sh_unix_check_selinux));
-
-  SL_RETURN(i, _("sh_unix_setcheckselinux"));
-}
-#endif
-
-#ifdef USE_ACL
-int sh_unix_setcheckacl (const char * c)
-{
-  int i;
-  SL_ENTER(_("sh_unix_setcheckacl"));
-  i = sh_util_flagval(c, &(sh_unix_check_acl));
-
-  SL_RETURN(i, _("sh_unix_setcheckacl"));
-}
-#endif
-
-#ifdef HAVE_LIBZ
-#include <zlib.h>
-#endif    
-
-
-static void * sh_dummy_filename;
-void * sh_dummy_tmp;
-void * sh_dummy_tmp2;
-
-int sh_unix_getinfo (int level, const char * filename, file_type * theFile, 
+int sh_unix_getinfo (int level, char * filename, file_type * theFile, 
 		     char * fileHash, int policy)
 {
@@ -3826,27 +2695,24 @@
   struct stat   lbuf;
   struct stat   fbuf;
-  volatile int  stat_return;
-  volatile int  stat_errno = 0;
-
+  int           stat_return;
+  register int  i;
   ShFileType    type;
   unsigned int  mode;
+  char        * name;
   char        * tmp;
   char        * tmp2;
-
+  /* char        * p; */
   char        * linknamebuf;
-  volatile int  linksize;
+  int           linksize;
 
   extern int get_the_fd (SL_TICKET ticket);
 
-  volatile SL_TICKET     rval_open;
-  volatile int           err_open = 0;
-
-  volatile int           fd;
-  volatile int           fstat_return;
-  volatile int           fstat_errno = 0;
-  volatile int           try         = 0;
-
-  sh_string   * content = NULL;
-      
+  SL_TICKET     rval_open;
+  int           fd;
+#if defined(__linux__)
+  int           fd_2;
+#endif
+  int           fstat_return;
+
   time_t        tend;
   time_t        tstart;
@@ -3855,83 +2721,44 @@
   char * path = NULL;
 
-  volatile int alert_timeout   = 120;
+  int alert_timeout   = 120;
 
   path = theFile->fullpath;
 
+#if 0
+  {
+    char pwd[256];
+    printf("%d %s %s %s (%s)\n", flagrel, theFile->fullpath, filename, path,
+	   getcwd (pwd, 256)); 
+  }
+#endif
+
   SL_ENTER(_("sh_unix_getinfo"));
 
-  if (!MODI_INITIALIZED(theFile->check_flags))
-    {
-      tmp2 = sh_util_safe_name (theFile->fullpath);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_SUBGPATH,
-		       _("Uninitialized check mask"), _("sh_unix_getinfo"),
-		       tmp2);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SH_FREE(tmp2);
-      SL_RETURN((-1),_("sh_unix_getinfo"));
-    }
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_filename = (void *) &filename;
-  sh_dummy_tmp      = (void *) &tmp;
-  sh_dummy_tmp2     = (void *) &tmp2;
-
   /* --- Stat the file, and get checksum. ---
    */
   tstart = time(NULL);
-
   stat_return = retry_lstat (FIL__, __LINE__, 
 			     path /* theFile->fullpath */, &buf);
 
-  if (stat_return)
-    stat_errno = errno;
-
-  theFile->link_path = NULL;
-
- try_again:
-
-  fd           = -1;
-  fstat_return = -1;
-  rval_open    = -1;
-
   if (stat_return == 0 && S_ISREG(buf.st_mode)) 
     {
-      rval_open = sl_open_fastread (FIL__, __LINE__, 
-				    path /* theFile->fullpath */, SL_YESPRIV);
-      if (SL_ISERROR(rval_open))
-	{
-	  char * stale = sl_check_stale();
-	  
-	  if (stale)
-	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, err_open, MSG_E_SUBGEN,
-			      stale, _("sh_unix_getinfo_open"));
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-
-	  if (errno == EBADF && try == 0) /* obsolete, but we keep this, just in case */
-	    {
-	      /* cppcheck-suppress syntaxError */
-	      ++try;
-	      goto try_again;
-	    }
-	  err_open = errno;
-	}
+      rval_open = sl_open_fastread (path /* theFile->fullpath */, SL_YESPRIV);
 
       alert_timeout = 120; /* this is per 8K block now ! */
 
-      if (path[1] == 'p' && path[5] == '/' && path[2] == 'r' &&
-	  path[3] == 'o' && path[4] == 'c' && path[0] == '/')
+      if (path[0] == '/' && path[1] == 'p' && path[2] == 'r' &&
+	  path[3] == 'o' && path[4] == 'c' && path[5] == '/')
 	{
 	  /* seven is magic */
 	  alert_timeout = 7;
 	}
-
-      fd = get_the_fd(rval_open);
-    }
+    }
+  else
+    rval_open = -1;
+
+  if (SL_ISERROR(rval_open))
+    fd = -1;
+  else
+    fd = get_the_fd(rval_open);
 
   tend = time(NULL);
@@ -3943,45 +2770,21 @@
     {
       tmp2 = sh_util_safe_name (theFile->fullpath);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_TOOLATE,
 		       (long)(tend - tstart), tmp2);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       SH_FREE(tmp2);
     }
-
+      
   if (fd >= 0) 
     {
       fstat_return = retry_fstat (FIL__, __LINE__, fd, &fbuf);
-
-      if (fstat_return)
-	{
-	  char * stale;
-
-	  fstat_errno = errno;
-
-	  stale = sl_check_stale();
-
-	  if (stale)
-	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, fstat_errno, 
-			      MSG_E_SUBGEN,
-			      stale, _("sh_unix_getinfo_fstat"));
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-
-	  if (try == 0) /* obsolete, but we keep this, just in case */
-	    {
-	      ++try;
-	      sl_close(rval_open);
-	      goto try_again;
-	    }
-	}
     }
   else
     {
-      fd = -1;
-    }
-      
+      fstat_return = -1;
+      fd           = -1;
+    }
+#if defined(__linux__)
+  fd_2 = fd;
+#endif
 
   /* ---  case 1: lstat failed  --- 
@@ -3994,24 +2797,11 @@
       if (sh.flag.checkSum == SH_CHECK_INIT || 
 	  (sh_hash_have_it (theFile->fullpath) >= 0 && 
-	   (!SH_FFLAG_REPORTED_SET(theFile->file_reported))))
+	   theFile->reported == S_FALSE))
 	{
 	  if (S_FALSE == sh_ignore_chk_del(theFile->fullpath)) {
-	    int flags = sh_hash_getflags (theFile->fullpath);
-
-	    if ((flags >= 0) && (flags & SH_FFLAG_ENOENT) == 0) {
-	      char errbuf[SH_ERRBUF_SIZE];
-	      uid_t euid;
-	      (void) sl_get_euid(&euid);
-	      tmp2 = sh_util_safe_name (theFile->fullpath);
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (level, FIL__, __LINE__, stat_return, MSG_FI_STAT,
-			       _("lstat"),
-			       sh_error_message (stat_errno, errbuf, sizeof(errbuf)),
-			       (long) euid,
-			       tmp2);
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	      SH_FREE(tmp2);
-	      sh_hash_set_flag (theFile->fullpath, SH_FFLAG_ENOENT);
-	    }
+	    tmp2 = sh_util_safe_name (theFile->fullpath);
+	    sh_error_handle (level, FIL__, __LINE__, stat_return, MSG_FI_LSTAT,
+			     sh_error_message (stat_return), tmp2);
+	    SH_FREE(tmp2);
 	  }
 	}
@@ -4019,10 +2809,11 @@
     }
 
-  /* ---  case 2: not a regular file  --- 
+  /* ---  case 2: not a regular file, or [IgnoreAll]  --- 
    */
   else if (! S_ISREG(buf.st_mode))
     {
       if (fileHash != NULL)
-	sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
+	strcpy(fileHash,                              /* known to fit */
+	       _("000000000000000000000000000000000000000000000000"));
     }
   
@@ -4038,50 +2829,24 @@
       if (fileHash != NULL)
 	{
-	  if ((theFile->check_flags & MODI_CHK) == 0 ||
-	      sh_restrict_this(theFile->fullpath, (UINT64) fbuf.st_size, 
-			       (UINT64) fbuf.st_mode, rval_open))
+	  if ((theFile->check_mask & MODI_CHK) == 0)
 	    {
-	      sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
+	      strcpy(fileHash,                         /* known to fit */
+		     _("000000000000000000000000000000000000000000000000"));
 	    }
-	  else if ((theFile->check_flags & MODI_PREL) != 0 &&
+	  else if (policy == SH_LEVEL_PRELINK && 
 		   S_TRUE == sh_prelink_iself(rval_open, fbuf.st_size, 
-					      alert_timeout, theFile->fullpath))
+					      alert_timeout))
 	    {
 	      if (0 != sh_prelink_run (theFile->fullpath, 
-				       fileHash, alert_timeout, theFile->check_flags))
-		sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
+				       fileHash, alert_timeout))
+		strcpy(fileHash,                       /* known to fit */
+		       _("000000000000000000000000000000000000000000000000"));
 	    }
 	  else
 	    {
-	      char hashbuf[KEYBUF_SIZE];
-	      UINT64 length_current = TIGER_NOLIM;
-
-	      if (MODI_TXT_ENABLED(theFile->check_flags) && fbuf.st_size < (10 * SH_TXT_MAX))
-		{
-		  sl_init_content (rval_open, fbuf.st_size);
-		}
-
-	      if (sh.flag.opts == S_TRUE) sh_tiger_set_hashtype_mask(theFile->check_flags);
-	      sl_strlcpy(fileHash,
-			 sh_tiger_generic_hash (theFile->fullpath, 
-						rval_open, &length_current, 
-						alert_timeout, 
-						hashbuf, sizeof(hashbuf)),
-			 KEY_LEN+1);
-
-	      content = sl_get_content(rval_open);
-	      content = sh_string_copy(content);
-
-	      if ((theFile->check_flags & MODI_SGROW) != 0)
-		{
-		  /* Update size so it matches the one for which the checksum
-		     has been computed */
-		  fbuf.st_size = length_current;
-		  buf.st_size  = fbuf.st_size;
-		  sl_rewind(rval_open);
-		  sh_unix_checksum_size (theFile->fullpath, length_current, S_TRUE,
-					 &fileHash[KEY_LEN + 1], 
-					 alert_timeout, rval_open, theFile->check_flags);
-		}
+	      tiger_fd = rval_open;
+	      strcpy(fileHash,                         /* known to fit */
+		     sh_tiger_generic_hash (theFile->fullpath, TIGER_FD, 0, 
+					    alert_timeout));
 	    }
 	}
@@ -4096,50 +2861,25 @@
       if (fileHash != NULL)
 	{
-	  if ((theFile->check_flags & MODI_CHK) == 0 ||
-	      sh_restrict_this(theFile->fullpath, (UINT64) fbuf.st_size, 
-			       (UINT64) fbuf.st_mode, rval_open))
+	  if ((theFile->check_mask & MODI_CHK) == 0)
 	    {
-	      sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
+	      strcpy(fileHash,                         /* known to fit */
+		     _("000000000000000000000000000000000000000000000000"));
 	    }
 	  else if (policy == SH_LEVEL_PRELINK &&
 		   S_TRUE == sh_prelink_iself(rval_open, fbuf.st_size, 
-					      alert_timeout, theFile->fullpath))
+					      alert_timeout))
 	    {
 	      if (0 != sh_prelink_run (theFile->fullpath, 
-				       fileHash, alert_timeout, theFile->check_flags))
-		sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
+				       fileHash, alert_timeout))
+		strcpy(fileHash,                       /* known to fit */
+		       _("000000000000000000000000000000000000000000000000"));
 	    }
 	  else
 	    {
-	      char hashbuf[KEYBUF_SIZE];
-	      UINT64 length_current = TIGER_NOLIM;
-
-	      if (MODI_TXT_ENABLED(theFile->check_flags) && fbuf.st_size < (10 * SH_TXT_MAX))
-		{
-		  sl_init_content (rval_open, fbuf.st_size);
-		}
-
-	      if (sh.flag.opts == S_TRUE) sh_tiger_set_hashtype_mask(theFile->check_flags);
+	      tiger_fd = rval_open;
 	      sl_strlcpy(fileHash, 
-			 sh_tiger_generic_hash (theFile->fullpath, rval_open, 
-						&length_current,
-						alert_timeout,
-						hashbuf, sizeof(hashbuf)),
+			 sh_tiger_generic_hash (theFile->fullpath, TIGER_FD, 0,
+						alert_timeout),
 			 KEY_LEN + 1);
-
-	      content = sl_get_content(rval_open);
-	      content = sh_string_copy(content);
-
-	      if ((theFile->check_flags & MODI_SGROW) != 0) 
-		{
-		  /* Update size so it matches the one for which the checksum
-		     has been computed */
-		  fbuf.st_size = length_current;
-		  buf.st_size  = fbuf.st_size;
-		  sl_rewind(rval_open);
-		  sh_unix_checksum_size (theFile->fullpath, length_current, S_TRUE,
-					 &fileHash[KEY_LEN + 1], 
-					 alert_timeout, rval_open, theFile->check_flags);
-		}
 	    }
 	}
@@ -4149,49 +2889,16 @@
    */
 
-  else    /* fstat_return != 0 or !S_ISREG(fbuf.st_mode) or open() failed */
-    {
-      uid_t   euid;
-
+  else    /* fstat_return != 0 or !S_ISREG(fbuf->st_mode) */
+    {
+      fstat_return = errno;
       if (fileHash != NULL)
-	sl_strlcpy(fileHash, SH_KEY_NULL, KEY_LEN+1);
-
-      if ((theFile->check_flags & MODI_CHK) != 0)
-	{
-	  tmp2 = sh_util_safe_name (theFile->fullpath);
-
-
-	  if (fd >= 0 && fstat_return != 0)
-	    {
-	      char errbuf[SH_ERRBUF_SIZE];
-	      (void) sl_get_euid(&euid);
-
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (level, FIL__, __LINE__, stat_return, MSG_FI_STAT,
-			       _("fstat"),
-			       sh_error_message (fstat_errno, errbuf, sizeof(errbuf)),
-			       (long) euid,
-			       tmp2);
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-	  else if (fd >= 0 && !S_ISREG(fbuf.st_mode))
-	    {
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (level, FIL__, __LINE__, fstat_errno, 
-			       MSG_E_NOTREG, tmp2);
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-	  else
-	    {
-	      char errbuf[SH_ERRBUF_SIZE];
-	      char errbuf2[SH_ERRBUF_SIZE];
-	      sl_strlcpy(errbuf, sl_error_string(rval_open), sizeof(errbuf));
-	      sh_error_message(err_open, errbuf2, sizeof(errbuf2));
-	      SH_MUTEX_LOCK(mutex_thread_nolog);
-	      sh_error_handle (level, FIL__, __LINE__, err_open, 
-			       MSG_E_READ, errbuf, errbuf2, tmp2);
-	      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-	    }
-	  SH_FREE(tmp2);
-	}
+	sl_strlcpy(fileHash, 
+		   _("000000000000000000000000000000000000000000000000"), 
+		   KEY_LEN + 1);
+
+      tmp2 = sh_util_safe_name (theFile->fullpath);
+      sh_error_handle (level, FIL__, __LINE__, fstat_return, MSG_E_READ,
+		       tmp2);
+      SH_FREE(tmp2);
     }	  
 
@@ -4199,43 +2906,25 @@
   /* --- Determine file type. ---
    */
-  memset (theFile->c_mode, '-', CMODE_SIZE-1);
-  theFile->c_mode[CMODE_SIZE-1] = '\0';
-
-  memset (theFile->link_c_mode, '-', CMODE_SIZE-1);
-  theFile->link_c_mode[CMODE_SIZE-1] = '\0';
+  for (i = 0; i < 10; ++i) theFile->c_mode[i] = '-';
+  theFile->c_mode[10] = '\0';
+  for (i = 0; i < 11; ++i) theFile->link_c_mode[i] = '-';
+  theFile->link_c_mode[10] = '\0';
 
   sh_unix_getinfo_type (&buf, &type, theFile->c_mode);
   theFile->type = type;
 
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
 
   /* --- Determine file attributes. ---
    */
-  memset (theFile->c_attributes, '-', ATTRBUF_SIZE);
-  theFile->c_attributes[ATTRBUF_USED] = '\0';
+  for (i = 0; i < 12; ++i) theFile->c_attributes[i] = '-';
+  theFile->c_attributes[12] = '\0';
   theFile->attributes      =    0;
 
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
   if (theFile->c_mode[0] != 'c' && theFile->c_mode[0] != 'b' &&
-      theFile->c_mode[0] != 'l' ) {
-    if (sh_unix_check_attributes == S_TRUE)
-      sh_unix_getinfo_attr(theFile->fullpath, 
-			   &theFile->attributes, theFile->c_attributes, 
-			   fd, &buf);
-  }
-#endif
-#endif
-
-#if defined(USE_XATTR) && defined(USE_ACL)
-  if (sh_unix_check_selinux == S_TRUE || sh_unix_check_acl == S_TRUE)
-    theFile->attr_string = sh_unix_getinfo_xattr (theFile->fullpath, fd, &buf);
-#elif defined(USE_XATTR)
-  if (sh_unix_check_selinux == S_TRUE)
-    theFile->attr_string = sh_unix_getinfo_xattr (theFile->fullpath, fd, &buf);
-#elif defined(USE_ACL)
-  if (sh_unix_check_acl == S_TRUE)
-    theFile->attr_string = sh_unix_getinfo_acl (theFile->fullpath, fd, &buf);
-#else
-  theFile->attr_string = NULL;
+      theFile->c_mode[0] != 'l' )
+    sh_unix_getinfo_attr(theFile->fullpath, 
+			 &theFile->attributes, theFile->c_attributes, fd_2);
+
 #endif
 
@@ -4278,5 +2967,8 @@
    */
 
-  if (NULL == sh_unix_getGIDname(SH_ERR_ALL, buf.st_gid, theFile->c_group, GROUP_MAX+1)) {
+  if ( (name = sh_unix_getGIDname(SH_ERR_ALL,
+				  buf.st_gid)) != NULL) {
+    sl_strlcpy (theFile->c_group, name, GROUP_MAX+1);
+  } else {
 
     tmp2 = sh_util_safe_name (theFile->fullpath);
@@ -4284,17 +2976,13 @@
     if (policy == SH_LEVEL_ALLIGNORE)
       {
-	SH_MUTEX_LOCK(mutex_thread_nolog);
 	sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, ENOENT, 
 			 MSG_FI_NOGRP,
 			 (long) buf.st_gid, tmp2);
-	SH_MUTEX_UNLOCK(mutex_thread_nolog);
       }
     else
       {
-	SH_MUTEX_LOCK(mutex_thread_nolog);
 	sh_error_handle (ShDFLevel[SH_ERR_T_NAME], FIL__, __LINE__, ENOENT, 
 			 MSG_FI_NOGRP,
 			 (long) buf.st_gid, tmp2);
-	SH_MUTEX_UNLOCK(mutex_thread_nolog);
       }
     SH_FREE(tmp2);
@@ -4303,5 +2991,8 @@
 
   
-  if (NULL == sh_unix_getUIDname(SH_ERR_ALL, buf.st_uid, theFile->c_owner, USER_MAX+1)) {
+  if ( (name = sh_unix_getUIDname(SH_ERR_ALL,
+				  buf.st_uid)) != NULL) {
+    sl_strlcpy (theFile->c_owner, name, USER_MAX+1);
+  } else {
 
     tmp2 = sh_util_safe_name (theFile->fullpath);
@@ -4309,17 +3000,13 @@
     if (policy == SH_LEVEL_ALLIGNORE)
       {
-	SH_MUTEX_LOCK(mutex_thread_nolog);
 	sh_error_handle (SH_ERR_ALL, FIL__, __LINE__, ENOENT, 
 			 MSG_FI_NOUSR,
 			 (long) buf.st_uid, tmp2);
-	SH_MUTEX_UNLOCK(mutex_thread_nolog);
       }
     else
       {
-	SH_MUTEX_LOCK(mutex_thread_nolog);
 	sh_error_handle (ShDFLevel[SH_ERR_T_NAME], FIL__, __LINE__, ENOENT, 
 			 MSG_FI_NOUSR,
 			 (long) buf.st_uid, tmp2);
-	SH_MUTEX_UNLOCK(mutex_thread_nolog);
       }
     SH_FREE(tmp2);
@@ -4329,10 +3016,9 @@
   /* --- Output the file. ---
    */
-  if (flag_err_debug == S_TRUE)
+  if (flag_err_debug == SL_TRUE)
     {
       tmp2 = sh_util_safe_name ((filename == NULL) ? 
 				theFile->fullpath : filename);
-      (void) sh_unix_time(theFile->mtime, timestr, sizeof(timestr));
-      SH_MUTEX_LOCK(mutex_thread_nolog);
+      sl_strlcpy(timestr, sh_unix_time(theFile->mtime), 81);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_LIST,
 		       theFile->c_mode,
@@ -4343,5 +3029,4 @@
 		       timestr,
 		       tmp2);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       SH_FREE(tmp2);
     }
@@ -4351,7 +3036,7 @@
   if (theFile->c_mode[0] == 'l') 
     {
+
       linknamebuf = SH_ALLOC(PATH_MAX);
 
-      /* flawfinder: ignore */
       linksize    = readlink (theFile->fullpath, linknamebuf, PATH_MAX-1);
 
